
#include <iostream>

#include "cifraRSA.hpp"

// ===//Funes Auxiliares (private)//===
 

void CifraRSA::crivoEratostenes(long int n, long int *contaPrimos, long int primos[]){
	// n > 2
	// lista de primos at n (inclusiv)
	
	int i;
	long int candidatos[comprimentoVector];
	contaPrimos = 0;
	
	/*  
	 *  inicializar, candidatos[2,3,4,5,6,7,...,n]
	 *  i = 0;
	 *  enquanto (i <= n-2)
	 *    // o primeiro elemento de candidatos (no nulo)  primo 
	 *    enquanto candidatos[i]  zero 
	 *         i++;
	 *    fimenquanto
	 *    primos[contaPrimos] <- candidatos[i];
	 *    contaPrimos++;
	 *    // aplicar o crivo candidatos[i] ---> i=0 ---> 2
	 *       ---> candidatos[0,3,0,5,0,7,...,n] ---> coloca a zero todos os mltiplos de 2...
	 * 
	 * 
	 */
}


bool CifraRSA::testaPrimo(long int cand) {
	long int i;
	
	for (i=2; i <= cand-1; i++) {
		if ((cand % i) == 0) {
			return false;
		}
	}
    return true;
}




// ===//(fim) Funes Auxiliares (private)//===

//===Criptoanlise da Cifra RSA===//

	// Mtodo das divises
	void CifraRSA::metodoDivisoes(long int n, long int *p, long int *q){	
	// constro a lista de primos at sqrt(n) 
	// [1,2,3,5,7,11,...,k] k<=sqrt(n)
	// p --- 2, ... at descobrir o primeiro factor primo de n
	// q = n/p
}

	/*
	 * Criptoanlise da cifra RSA usando a frmula geradora 6k+-1
	 * --> n: natural factor de dois primos
	 * <-- p,q: naturais, tais que n=p*q
	 */
	void CifraRSA::formulaGeradora(long int n, long int *p, long int *q){
		long int k; 
		long int candidato1,candidato2;
		
		k=1;
		while (6*k+1 <= ceil(sqrt(n))) {
			// gera potenciais primos atravs da frmula 6k+-1
			candidato1 = 6*k-1;
			candidato2 = 6*k+1;
			
			// verifica se cada um dos candidatos , ou no primo
			if (testaPrimo(candidato1)){
				if ( n % candidato1 == 0){
					*p = candidato1;
					*q = n / candidato1; // diviso inteira
				} // seno, no fao nada
			}
			if (testaPrimo(candidato2)){
				if ( n % candidato2 == 0){
					*p = candidato2;
					*q = n / candidato2; // diviso inteira
				} // seno, no fao nada
			}
			k++;
		}
	}
	

	void CifraRSA::metodoFermat(long int n, long int *p, long int *q){
	// 
	
	}

//===(fim)Criptoanlise da Cifra RSA===//

//===Cifra RSA===//

// gerarChaves
// cifrarRSA
// decifrarRSA

//===(fim)Cifra RSA===//
