/*
 * crivoEratostenes.cpp
 * 
 * Copyright 2021 Pedro Quaresma <pedro@fenix>
 * 
 * 
 * 
 */


#include <iostream>

#define NUMELEMENTOS 500000

using namespace std;

void escreverVector(int  lista[],int comprimento) {
	int i;
	
	for (i=0;i<comprimento-1;i++) {
		cout << lista[i] << ",";
		if ((i+1) % 10 == 0) cout << endl;
	}
	cout << lista[comprimento-1] << "\n";
}



/*
 * Cálculo de números primos até um dado n
 * 
 * --> n
 * <-- lista de primos até n (escrever no ecrã
 */ 
int main() {
  // definir duas listas (vectores), de candidatos e de números primos
  int crivo[NUMELEMENTOS]; // vector com 1000 elementos no máximo, para guardar os candidatos
  int primos[NUMELEMENTOS]; // vector com 1000 elementos no máximo, para guardar os primos
	
  int numPrimos,contaPrimos=0;
  int candidatos=0;
  int i,aux;
	
	
  cout << "Introduza um inteiro (primos até esse valor) ";
  cin >> numPrimos;
	
  // preencher a lista de candidatos com os valores de 2 até n, crivo[2,3,4,5,6,7,8,9,...,n]
  for (i=2; i<= numPrimos; i++) { 
    crivo[i-2] = i;
  }
  // colocar o 1 na lista de primos, primos[1,?,?,?,?,...]
  primos[contaPrimos]=1;
  contaPrimos++;
		
  // ciclo de todos os crivos até n (n-2 em termos do vector)
  while (candidatos <= numPrimos-2) {
    // o primeiro elemento não nulo do crivo é um número primos [-,-,0
    while ((candidatos <= numPrimos-2) && (crivo[candidatos] == 0)) {   // [2,3,4,...] [0,3,0,...] [0,0,0,5,...]
      candidatos++;
    }
    // colocar o elemento no vector de primos
    primos[contaPrimos] = crivo[candidatos]; // [1,2... [1,2,3,...
    contaPrimos++;
    // aplicar o crivo de ordem 'candidatos' 2--> [0,3,0,... 3--> [0,0,0,5,0,7,... 5-->[0,0,0,0,0,7,...
    aux = candidatos;
    while (aux <= numPrimos-2) {
      crivo[aux] = 0;
      aux = aux+primos[contaPrimos-1];
    }
  }
	
  // Mostrar a lista de primos

  cout << "Número de primos até " << numPrimos << ": " << contaPrimos << endl;
  
  cout << "Lista de primos até " << numPrimos << "\n ";
  escreverVector(primos,contaPrimos-1);
  cout << endl;
	
  return 0;
}

