/*
 * formulaGeradoa.cpp
 * 
 * Copyright 2021 Pedro Quaresma <pedro@fenix>
 * 
 */


#include <iostream>
#include <cmath>       /* sqrt */
#include "cifraRSA.hpp"

using namespace std;


/*
 * Achar os factores primos de n = pq, através da fórmula geradora de primos
 * 6k+-1
 * 
 * --> n   
 * <-- p,q: n=p*q
 * 
 * Nota: não se vai testar 2,3, considera-se que p e q são >> do que 3
 */ 
int main() {
	long int n;
	long int p,q;
	
	CifraRSA cifraRSA;
	
	cout << "Introduza um inteiro n, factor de dois primos) ";
	cin >> n;
	
	/*
	 * Ponteiro 
	 * int *a; --- definição de uma variável do tipo ponteiro para inteiro
	 * *a --- apontado por 'a' (valor)
	 * &a --- ponteiro 'a'
	 */	
	 
	cifraRSA.formulaGeradora(n,&p,&q);
	
	// devolve p,q
	cout << "Os factores primos de " << n << " são: " << p << " e " << q << endl;
	
	return 0;
}

