/*
 * metodoFermat.cpp
 * 
 * Copyright 2021 Pedro Quaresma <pedro@fenix>
 * 
 */


#include <iostream>
#include <cmath>       /* sqrt */

using namespace std;


/*
 * Utiliza o Método de Fermat para calcular os factores primos de um dado n
 * --> n: inteiro resultado do producto de dois primos
 * <-- p,q: n=p*q
 */ 
int main() {
	long int n;
	long int p,q;
	long int a;
	double b;
	int i;
	
	// Ler o valor a factorizar
	cout << "Introduza um inteiro n, factor de dois primos) ";
	cin >> n;

	// Aplicar o método de Fermat
	
	a = trunc(sqrt(n)) + 1;  // trunc(agem) 5.8 ---> 5
	i = 1;

	do {
		b = sqrt(a*a -n);
	    cout << "A tentativa: " << i << " com a = " << a << ", b = " << b << endl;
	    a++;
	    i++;
	} while (b != trunc(b));   // abs(b-trunc(b)) < 10E-6 
	a--; // para corrigir o último incremento do 'a'
	
	p = a - b;
	q = a + b;
	
	// Escreve os dois factores primos de n, p,q
	cout << "Os factores primos de " << n << " são: " << p << " e " << q << endl;
	
	return 0;
}
